libzypp: zypp::repo Namespace Reference

libzypp 17.38.14

zypp::repo Namespace Reference

## Namespaces
namespace | factory
namespace | yum
namespace | env

## Classes
class | DeltaCandidates
| Candidate delta and patches for a package. More...
class | RpmSigCheckException
| Exception thrown by PackageProviderImpl::rpmSigFileChecker. More...
class | PackageProviderImpl
class | RpmPackageProvider
| RPM PackageProvider implementation (with deltarpm processing). More...
class | PackageProviderPolicy
| Policies and options for PackageProvider. More...
class | PackageProvider
| Provide a package from a Repo. More...
class | PluginServices
class | RepoException
| Exception for repository handling. More...
class | RepoNotCachedException
| The repository cache is not built yet so you can't create the repostories from the cache. More...
class | RepoNoUrlException
| thrown when it was impossible to determine one url for this repo. More...
class | RepoNoAliasException
| thrown when it was impossible to determine an alias for this repo. More...
class | RepoInvalidAliasException
| Thrown when the repo alias is found to be invalid. More...
class | RepoNotFoundException
| thrown when it was impossible to match a repository More...
class | RepoAlreadyExistsException
| Repository already exists and some unique attribute can't be duplicated. More...
class | RepoUnknownTypeException
| thrown when it was impossible to determine this repo type. More...
class | RepoMetadataException
| thrown when it was impossible to use the raw metadata for this repo. More...
class | RepoNoPermissionException
| thrown if the user has no permission to update(write) the caches. More...
class | ServiceException
| Base Exception for service handling. More...
class | ServiceNoAliasException
| Service without alias was used in an operation. More...
class | ServiceInvalidAliasException
| Thrown when the repo alias is found to be invalid. More...
class | ServiceAlreadyExistsException
| Service already exists and some unique attribute can't be duplicated. More...
class | ServiceNoUrlException
| Service has no or invalid url defined. More...
class | ServicePluginException
| PLUGIN Service related exceptions. More...
class | ServicePluginInformalException
| Service plugin has trouble providing the metadata but this should not be treated as error. More...
class | ServicePluginImmutableException
| Service plugin is immutable. More...
class | RepoInfoBase
| Base class implementing common features of RepoInfo and ServiceInfo. More...
class | RepoMirrorList
class | RepoMediaAccess
| Provides files from different repos. More...
struct | RepoType
| Repository type enumeration. More...
class | RepoVarExpand
| Functor expanding repo variables in a string. More...
struct | RepoVariablesStringReplacer
| Functor replacing repository variables. More...
struct | RepoVariablesUrlReplacer
| Functor replacing repository variables. More...
struct | ServiceType
| Service type enumeration. More...
class | SrcPackageProvider
struct | SMVData
| Data parsed from a media.1/media file. More...
class | SUSEMediaVerifier
| Implementation of the traditional SUSE media verifier. More...
struct | DownloadResolvableReport
struct | ProbeRepoReport
struct | RepoCreateReport
struct | RepoReport

## Typedefs
using | RepoInfoBase_Ptr = shared_ptr<RepoInfoBase>
| relates: RepoInfoBase
using | RepoInfoBase_constPtr = shared_ptr<const RepoInfoBase>
| relates: RepoInfoBase

## Functions
std::ostream & | operator<< (std::ostream &str, const DeltaCandidates::Impl &obj)
| relates: DeltaCandidates::Impl Stream output
std::ostream & | operator<< (std::ostream &str, const DeltaCandidates &obj)
| relates: DeltaCandidates Stream output
template<class RepoIter>
DeltaCandidates | makeDeltaCandidates (RepoIter begin_r, RepoIter end_r)
| relates: DeltaCandidates Convenient construction.
template<class RepoContainer>
DeltaCandidates | makeDeltaCandidates (const RepoContainer &cont_r)
| relates: DeltaCandidates Convenient construction.
std::ostream & | operator<< (std::ostream &str, const PluginServices &obj)
| relates: ServiceFileReader Stream output
| DEF_CTORS (RepoNotCachedException, "Repository is not cached")
| DEF_CTORS (RepoNoUrlException, "Repository has no or invalid url defined.")
| DEF_CTORS (RepoNoAliasException, "Repository has no alias defined.")
| DEF_CTORS (RepoInvalidAliasException, "Repository has an invalid alias.")
| DEF_CTORS (RepoNotFoundException, "Repository not found.")
| DEF_CTORS (RepoAlreadyExistsException, "Repository already exists.")
| DEF_CTORS (RepoUnknownTypeException, "Repository type can't be determined.")
| DEF_CTORS (RepoMetadataException, "Repository metadata not usable.")
| DEF_CTORS (RepoNoPermissionException, _("No permission to write repository cache."))
| DEF_CTORS (ServiceNoAliasException, "Service has no alias defined.")
| DEF_CTORS (ServiceInvalidAliasException, "Service has an invalid alias.")
| DEF_CTORS (ServiceAlreadyExistsException, "Service already exists.")
| DEF_CTORS (ServiceNoUrlException, "Service has no or invalid url defined.")
| DEF_CTORS (ServicePluginException, "PLUGIN service exception.")
| DEF_CTORS (ServicePluginInformalException, "Service plugin has trouble providing the metadata but this should not be treated as error.")
| DEF_CTORS (ServicePluginImmutableException, _("Service plugin does not support changing an attribute."))
std::ostream & | operator<< (std::ostream &str, const RepoInfoBase &obj)
| relates: RepoInfoBase Stream output
bool | operator== (const RepoInfoBase &lhs, const RepoInfoBase &rhs)
| relates: RepoInfoBase
bool | operator!= (const RepoInfoBase &lhs, const RepoInfoBase &rhs)
| relates: RepoInfoBase
bool | operator< (const RepoInfoBase &lhs, const RepoInfoBase &rhs)
ManagedFile | provideFile (RepoInfo repo_r, const OnMediaLocation &loc_r, const ProvideFilePolicy &policy_r=ProvideFilePolicy())
| Provide a file from a Repository.
std::vector< Pathname > | repositoryCachePaths (RepoInfo repo_r)
| returns a set of paths.
std::ostream & | operator<< (std::ostream &str, const RepoType &obj)
bool | operator== (const RepoType &obj1, const RepoType &obj2)
bool | operator!= (const RepoType &obj1, const RepoType &obj2)
std::ostream & | operator<< (std::ostream &str, const ServiceType &obj)
bool | operator== (const ServiceType &obj1, const ServiceType &obj2)
bool | operator!= (const ServiceType &obj1, const ServiceType &obj2)
std::ostream & | operator<< (std::ostream &str, const SMVData &obj)
| relates: SMVData Stream output
std::ostream & | operator<< (std::ostream &str, const SUSEMediaVerifier::Impl &obj)
| relates: SUSEMediaVerifier::Impl Stream output
std::ostream & | operator<< (std::ostream &str, const SUSEMediaVerifier &obj)

## Typedef Documentation

## ◆ RepoInfoBase_Ptr

using zypp::repo::RepoInfoBase_Ptr = shared_ptr<RepoInfoBase>

relates: RepoInfoBase

Definition at line 187 of file RepoInfoBase.h.

## ◆ RepoInfoBase_constPtr

using zypp::repo::RepoInfoBase_constPtr = shared_ptr<const RepoInfoBase>

relates: RepoInfoBase

Definition at line 189 of file RepoInfoBase.h.

## Function Documentation

## ◆ operator<<() [1/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const DeltaCandidates::Impl & | obj )
| inline

relates: DeltaCandidates::Impl Stream output

Definition at line 55 of file DeltaCandidates.cc.

## ◆ operator<<() [2/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const DeltaCandidates & | obj )

relates: DeltaCandidates Stream output

Definition at line 108 of file DeltaCandidates.cc.

## ◆ makeDeltaCandidates() [1/2]

template<class RepoIter>

DeltaCandidates zypp::repo::makeDeltaCandidates | ( | RepoIter | begin_r,
|  | RepoIter | end_r )
| inline

relates: DeltaCandidates Convenient construction.

Todo
  templated ctor

Definition at line 76 of file DeltaCandidates.h.

## ◆ makeDeltaCandidates() [2/2]

template<class RepoContainer>

DeltaCandidates zypp::repo::makeDeltaCandidates | ( | const RepoContainer & | cont_r | ) |
| inline

relates: DeltaCandidates Convenient construction.

Todo
  templated ctor

Definition at line 83 of file DeltaCandidates.h.

## ◆ operator<<() [3/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const PluginServices & | obj )

relates: ServiceFileReader Stream output

Definition at line 80 of file PluginServices.cc.

## ◆ DEF_CTORS() [1/16]

zypp::repo::DEF_CTORS | ( | RepoNotCachedException | ,
|  | "Repository is not cached" | )

## ◆ DEF_CTORS() [2/16]

zypp::repo::DEF_CTORS | ( | RepoNoUrlException | ,
|  | "Repository has no or invalid url defined." | )

## ◆ DEF_CTORS() [3/16]

zypp::repo::DEF_CTORS | ( | RepoNoAliasException | ,
|  | "Repository has no alias defined." | )

## ◆ DEF_CTORS() [4/16]

zypp::repo::DEF_CTORS | ( | RepoInvalidAliasException | ,
|  | "Repository has an invalid alias." | )

## ◆ DEF_CTORS() [5/16]

zypp::repo::DEF_CTORS | ( | RepoNotFoundException | ,
|  | "Repository not found." | )

## ◆ DEF_CTORS() [6/16]

zypp::repo::DEF_CTORS | ( | RepoAlreadyExistsException | ,
|  | "Repository already exists." | )

## ◆ DEF_CTORS() [7/16]

zypp::repo::DEF_CTORS | ( | RepoUnknownTypeException | ,
|  | "Repository type can't be determined." | )

## ◆ DEF_CTORS() [8/16]

zypp::repo::DEF_CTORS | ( | RepoMetadataException | ,
|  | "Repository metadata not usable." | )

## ◆ DEF_CTORS() [9/16]

zypp::repo::DEF_CTORS | ( | RepoNoPermissionException | ,
|  | _("No permission to write repository cache.") | )

## ◆ DEF_CTORS() [10/16]

zypp::repo::DEF_CTORS | ( | ServiceNoAliasException | ,
|  | "Service has no alias defined." | )

## ◆ DEF_CTORS() [11/16]

zypp::repo::DEF_CTORS | ( | ServiceInvalidAliasException | ,
|  | "Service has an invalid alias." | )

## ◆ DEF_CTORS() [12/16]

zypp::repo::DEF_CTORS | ( | ServiceAlreadyExistsException | ,
|  | "Service already exists." | )

## ◆ DEF_CTORS() [13/16]

zypp::repo::DEF_CTORS | ( | ServiceNoUrlException | ,
|  | "Service has no or invalid url defined." | )

## ◆ DEF_CTORS() [14/16]

zypp::repo::DEF_CTORS | ( | ServicePluginException | ,
|  | "PLUGIN service exception." | )

## ◆ DEF_CTORS() [15/16]

zypp::repo::DEF_CTORS | ( | ServicePluginInformalException | ,
|  | "Service plugin has trouble providing the metadata but this should not be treated as error." | )

## ◆ DEF_CTORS() [16/16]

zypp::repo::DEF_CTORS | ( | ServicePluginImmutableException | ,
|  | _("Service plugin does not support changing an attribute.") | )

## ◆ operator<<() [4/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const RepoInfoBase & | obj )

relates: RepoInfoBase Stream output

Definition at line 166 of file RepoInfoBase.cc.

## ◆ operator==() [1/3]

bool zypp::repo::operator== | ( | const RepoInfoBase & | lhs,
|  | const RepoInfoBase & | rhs )
| inline

relates: RepoInfoBase

Definition at line 173 of file RepoInfoBase.h.

## ◆ operator!=() [1/3]

bool zypp::repo::operator!= | ( | const RepoInfoBase & | lhs,
|  | const RepoInfoBase & | rhs )
| inline

relates: RepoInfoBase

Definition at line 177 of file RepoInfoBase.h.

## ◆ operator<()

bool zypp::repo::operator< | ( | const RepoInfoBase & | lhs,
|  | const RepoInfoBase & | rhs )
| inline

Definition at line 180 of file RepoInfoBase.h.

## ◆ provideFile()

ManagedFile zypp::repo::provideFile | ( | RepoInfo | repo_r,
|  | const OnMediaLocation & | loc_r,
|  | const ProvideFilePolicy & | policy_r = ProvideFilePolicy() )

Provide a file from a Repository.

Let source_r provide the file described by loc_r. In case loc_r contains a checksum, the file is verified. policy_r provides callback hooks for download progress reporting and behaviour on failed checksum verification.

Exceptions

  Exception |

Definition at line 121 of file RepoProvideFile.cc.

## ◆ repositoryCachePaths()

std::vector< Pathname > zypp::repo::repositoryCachePaths | ( | RepoInfo | repo_r | ) |

returns a set of paths.

Depending on the privilege level of the effective user, the path requested will be

- the user r/w cache location if it's a regular unprivileged user
- the system r/o cache location otherwise
  Parameters

    repo_r |

  Returns
    a list of paths

Definition at line 129 of file RepoProvideFile.cc.

## ◆ operator<<() [5/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const RepoType & | obj )
| inline

Definition at line 59 of file RepoType.h.

## ◆ operator==() [2/3]

bool zypp::repo::operator== | ( | const RepoType & | obj1,
|  | const RepoType & | obj2 )
| inline

Definition at line 62 of file RepoType.h.

## ◆ operator!=() [2/3]

bool zypp::repo::operator!= | ( | const RepoType & | obj1,
|  | const RepoType & | obj2 )
| inline

Definition at line 65 of file RepoType.h.

## ◆ operator<<() [6/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const ServiceType & | obj )
| inline

Definition at line 68 of file ServiceType.h.

## ◆ operator==() [3/3]

bool zypp::repo::operator== | ( | const ServiceType & | obj1,
|  | const ServiceType & | obj2 )
| inline

Definition at line 71 of file ServiceType.h.

## ◆ operator!=() [3/3]

bool zypp::repo::operator!= | ( | const ServiceType & | obj1,
|  | const ServiceType & | obj2 )
| inline

Definition at line 74 of file ServiceType.h.

## ◆ operator<<() [7/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const SMVData & | obj )
| inline

relates: SMVData Stream output

Definition at line 60 of file SUSEMediaVerifier.cc.

## ◆ operator<<() [8/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const SUSEMediaVerifier::Impl & | obj )
| inline

relates: SUSEMediaVerifier::Impl Stream output

Definition at line 117 of file SUSEMediaVerifier.cc.

## ◆ operator<<() [9/9]

std::ostream & zypp::repo::operator<< | ( | std::ostream & | str,
|  | const SUSEMediaVerifier & | obj )

Definition at line 205 of file SUSEMediaVerifier.cc.